#ifndef SUBDIVISION_H
#define SUBDIVISION_H

#include <QtOpenGL>
#include <QOpenGLFunctions_4_3_Core>

#include "mesh.h"

class Subdivision
{
public:
    Subdivision(QOpenGLFunctions_4_3_Core *f);
    ~Subdivision();

    void init();
    Mesh *subdivide(Mesh *mesh);

private:
    QOpenGLFunctions_4_3_Core *f;
    QOpenGLShaderProgram *edgeShader;

    QOpenGLShaderProgram *initEdgeComputeShaderProgram();
    void precomputeTables(Mesh *mesh, QVector<QVector<unsigned int> > &edgeIndices_base,
                          QVector<unsigned int> &vertexIndices, QVector<unsigned int> &vertexIndicesOffsets);
    void runShader(Mesh *mesh, QVector<QVector<unsigned int> > &edgeIndices);

    QVector<unsigned int> fillVector(unsigned int a, unsigned int b, unsigned int c,unsigned int d);
};

#endif
